function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for(var i = 0, arr2 = new Array(len); i < len; i++)arr2[i] = arr[i];
    return arr2;
}
function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
}
function _iterableToArrayLimit(arr, i) {
    var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];
    if (_i == null) return;
    var _arr = [];
    var _n = true;
    var _d = false;
    var _s, _e;
    try {
        for(_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true){
            _arr.push(_s.value);
            if (i && _arr.length === i) break;
        }
    } catch (err) {
        _d = true;
        _e = err;
    } finally{
        try {
            if (!_n && _i["return"] != null) _i["return"]();
        } finally{
            if (_d) throw _e;
        }
    }
    return _arr;
}
function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}
function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(n);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}
import { defaultStyles, makeAnsiCode } from './codes.js';
// Base styles for ANSI, RGB and HEX
export var ansiForeground = {
    open: 38,
    close: 39
};
export var ansiBackground = {
    open: 48,
    close: 49
};
export var ansiMatcher = /^(bg)?(ansi):(\d+)(?:[,;](\d+)[,;](\d+))?$/i;
export var rgbMatcher = /^(bg)?(rgb):(\d+)[,;](\d+)[,;](\d+)$/i;
export var hexMatcher = /^(bg)?(hex):#?([\da-f]{2})([\da-f]{2})([\da-f]{2})$/i;
export function convertColorSpec(name) {
    // eslint-disable-next-line @typescript-eslint/prefer-nullish-coalescing
    var lastMatch = name.match(ansiMatcher) || name.match(rgbMatcher) || name.match(hexMatcher) || [];
    lastMatch = lastMatch.map(function(m) {
        return m ? m.toLowerCase() : m;
    });
    var ansiBase = lastMatch[1] && lastMatch[1] === 'bg' ? ansiBackground : ansiForeground;
    var base = lastMatch[2] === 'hex' ? 16 : 0;
    var ref = _slicedToArray(lastMatch.slice(3, 6).map(function(c) {
        return c ? Number.parseInt(c, base) : -1;
    }), 3), r = ref[0], g = ref[1], b = ref[2];
    if (lastMatch[2] === 'ansi') {
        // Short color spec - Valid if r goes from 16 to 255, included
        if (r > 16 && r < 256 && g === -1) {
            return makeAnsiCode([
                ansiBase.open,
                5,
                r
            ], ansiBase.close);
        }
        // Full color spec - Valid if each component goes from 0 to 5, included
        return r >= 0 && g >= 0 && b >= 0 && r <= 5 && g <= 5 && b <= 5 ? makeAnsiCode([
            ansiBase.open,
            5,
            16 + r * 36 + g * 6 + b
        ], ansiBase.close) : null;
    } else if (lastMatch[2]) {
        // RGB or HEX, since HEX has been converted to INT, it's the same thing - Valid if each component goes from 0 to 255, included
        return r >= 0 && g >= 0 && b >= 0 && r <= 255 && g <= 255 && b <= 255 ? makeAnsiCode([
            ansiBase.open,
            2,
            r,
            g,
            b
        ], ansiBase.close) : null;
    }
    return defaultStyles[name] || null;
}
